function OnSimulationStart()
{
    LogDebug("OnSimulationStart called");
			
	OperateMechanism(function () { 
		/* OnStart */
		/* FollowConveyorView's camera will always follow the vehicle */
		ZoomAndFollowEquipment("Conveyor2", "FollowConveyorView", 2);				
	},
	function (sender, product) {
		/* OnProductAdded */	
		/* When a product is created, the camera will zoom to it and follow it across the mechanism */
		ZoomAndFollowEquipment(product.Name, "FollowProductView", 1.2);			
	},
	function () {
		/* OnProductRemoved */
		/* When the product is near deletion, the camera will stop following the product */
		StopZoomAndFollowEquipment("FollowProductView");			
	});		
}

function OperateMechanism(OnStart, OnProductAdded, OnProductRemoved) 
{			
	var c2 = GetComponentByNameAndType("Conveyor2", "Conveyor");
	var vehicle = GetComponentByNameAndType("BasicShape1", "Basic Shape");
		
	SetTimerEx(1, 500, function () { 
		OnStart(); CreateProductOnMechanism();		
	}, null);
			
	SubscribeToEvent("OnProductBlocking", "PESensor3", "PE Sensor", OnProductAdded);	
	SubscribeToEvent("OnProductBlocking", "PESensor1", "PE Sensor", OnProductRemoved);	
	
	SubscribeToEvent("OnProductBlocking", "PESensor2","PE Sensor", function () {	
		c2.Running = false;
		
		vehicle.GoToPosition(17.3109112747582, 1.04503110640317, -1.1, 3, 3, 3, function () {			
			c2.Running = true;
		});
	});
	
	SubscribeToEvent("OnProductRemoved", "Conveyor2", "Conveyor", function () {				
		c2.Running = false;		
		
		vehicle.GoToPosition(7.41091127475819, 1.04503110640317, -1.1, 3, 3, 3, function () {
			c2.Running = true;	
			CreateProductOnMechanism();
		});
	});
}

function CreateProductOnMechanism()
{		
	var prod = CreateProduct();	
	MoveProduct(prod, "Conveyor1", 0);	
}

function OnSimulationStopping() 
{
    LogDebug("OnSimulationStopping called");
    DeleteAllProducts();
}

function OnSimulationStop()
{
    LogDebug("OnSimulationStop called");
}